//  File:  expr.g  -  from An Intro To ANTLR
//============================================

grammar expr1;

expr1
    :	  expr
    ;

expr:   mexpr ((PLUS|MINUS) mexpr)*
    ;

mexpr      
    :   atom (STAR atom)*
    ;

atom:   INT 
    |   LPAREN expr RPAREN 
    ;

LPAREN:  '(' ;
RPAREN:  ')' ;
PLUS  :  '+' ;
MINUS :  '-' ;
STAR  :  '*' ;
INT   :  ('0'..'9')+ ;
WS	:  (' ' | '\t' | '\r' | '\n')+ { $channel=HIDDEN; }
	;

//===========================================
