//  File:  Main.java  -  Launch the ANTLR-originated code

import antlr.*;
import antlr.collections.*;

public class Main {

    public static void main(String[] args) throws Exception {
        ExprLexer lexer   = new ExprLexer(System.in);
        ExprParser parser = new ExprParser(lexer);
        parser.expr();
        AST ast = parser.getAST();
        System.out.println(ast.toStringTree());
    }

}    
